---
title: PUT
slug: Web/HTTP/Methods/PUT
tags:
  - HTTP
  - Reference
  - Request method
---
<div>{{HTTPSidebar}}</div>

<p>The <strong>HTTP <code>PUT</code> request method</strong> creates a new resource or replaces a representation of the target resource with the request payload.</p>

<p>The difference between <code>PUT</code> and {{HTTPMethod("POST")}} is that <code>PUT</code> is idempotent: calling it once or several times successively has the same effect (that is no <em>side</em> effect), whereas successive identical {{HTTPMethod("POST")}} requests may have additional effects, akin to placing an order several times.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Request has body</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Successful response has body</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Safe")}}</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Idempotent")}}</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Cacheable")}}</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Allowed in <a href="/en-US/docs/Web/Guide/HTML/Forms">HTML forms</a></th>
   <td>No</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">PUT /new.html HTTP/1.1
</pre>

<h2 id="Example">Example</h2>

<h3 id="Request">Request</h3>

<pre class="notranslate">PUT /new.html HTTP/1.1
Host: example.com
Content-type: text/html
Content-length: 16

&lt;p&gt;New File&lt;/p&gt;</pre>

<h3 id="Responses">Responses</h3>

<p>If the target resource does not have a current representation and the <code>PUT</code> request successfully creates one, then the origin server must inform the user agent by sending a {{HTTPStatus("201")}} (<code>Created</code>) response.</p>

<pre class="newpage notranslate">HTTP/1.1 201 Created
Content-Location: /new.html</pre>

<p>If the target resource does have a current representation and that representation is successfully modified in accordance with the state of the enclosed representation, then the origin server must send either a {{HTTPStatus("200")}} (<code>OK</code>) or a {{HTTPStatus("204")}} (<code>No Content</code>) response to indicate successful completion of the request.</p>

<pre class="notranslate">HTTP/1.1 204 No Content
Content-Location: /existing.html
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7231", "PUT", "4.3.4")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.methods.PUT")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPStatus("201")}}</li>
 <li>{{HTTPStatus("204")}}</li>
</ul>
